$(function () {
    let url = "https://api.geeksend.com/";
    let website_url = "https://app.geeksend.com/"
    let sessionobj = {}
    let all_emails = [];//所有域名邮箱集合
    let potential_info = [];//所有潜在客户集合
    let list_id;//当前选择的潜在客户列表
    let parser;
    let is_gs = false;
    const REG_GOOGLE_RESULT_URL = /<cite class=".+?">(.+?)<\/cite>/ig;
    const REG_GOOGLE_RESULT_URL_TRIM = /(.+?)(<|$)/i;
    let googleResult = [];
    let all_urls = [];//所有公司集合
    let engine_list_id;//当前选择的公司列表
    let potential_total = 0;
    let all_total = 0;
    let type = "all";
    let login_loading;
    let search_loading;
    let currentHost = '';
    let company_info = [];//当前域名公司信息
    let prospect_list = [];//用户创建的用于保存邮箱和潜在客户的列表
    let allActiveNumber = 0;
    let potentialActiveNumber = 0;
    let limit = 20;
    let allPage = 1;
    let companyEmailTotal = 0;
    let potentialPage = 1;
    let allScrollTrue = true;
    let PotentialScrollTrue = true;
    let isRequesting = false;
    // function initPopupTabsQuery(tab = {}) {
    //     chrome.tabs.query({active: true, currentWindow: true}, tabs => {
    //         tab_send_msg(tab[0])
    //     });
    // }
    let progress_bar=0;
    let ui_locale = "en";//语言 en是英文，zh-cn是中文
    chrome.cookies.set({
        'name': 'search_extension_version',
        'url': 'https://app.geeksend.com/',
        'domain': '.geeksend.com',
        'path': '/',
        'value': chrome.runtime.getManifest().version,
        'expirationDate': (new Date() / 1000) + 3600 * 24 * 30,
        'secure': true,
        'sameSite': 'lax'
    }, function (cookie) {

    });
    $(".extended__version").text(`v${chrome.runtime.getManifest().version}`)
    ui_locale = chrome.i18n.getMessage("@@ui_locale");
    if(!ui_locale.includes("zh")){
        ui_locale = "en";
        $(".locale__loading_title").text(chrome.i18n.getMessage("locale__loading_title"))
        $(".locale__login_instructions").text(chrome.i18n.getMessage("locale__login_instructions"))
        $(".locale__to_login").text(chrome.i18n.getMessage("locale__to_login"))
        $(".locale__no_reg").text(chrome.i18n.getMessage("locale__no_reg"))
        $(".locale__to_reg").text(chrome.i18n.getMessage("locale__to_reg"))
        $(".locale__span1").text(chrome.i18n.getMessage("locale__span1"))
        $(".locale__span2").text(chrome.i18n.getMessage("locale__span2"))
        $(".locale__no_search_title").text(chrome.i18n.getMessage("locale__no_search_title"))
        $(".locale__search_google").text(chrome.i18n.getMessage("locale__search_google"))
        $(".locale__search_google_des").text(chrome.i18n.getMessage("locale__search_google_des"))
        $(".locale__search_website").text(chrome.i18n.getMessage("locale__search_website"))
        $(".locale__search_website_des").text(chrome.i18n.getMessage("locale__search_website_des"))
        $(".locale__search_twitter").text(chrome.i18n.getMessage("locale__search_twitter"))
        $(".locale__search_twitter_des").text(chrome.i18n.getMessage("locale__search_twitter_des"))
        $(".locale__search_yelp").text(chrome.i18n.getMessage("locale__search_yelp"))
        $(".locale__search_yelp_des").text(chrome.i18n.getMessage("locale__search_yelp_des"))
        $(".locale__potential_type").text(chrome.i18n.getMessage("locale__potential_type"))
        $(".locale__all_type").text(chrome.i18n.getMessage("locale__all_type"))
        $(".locale__select_all").text(chrome.i18n.getMessage("locale__select_all"))
        $(".locale__copy_all").text(chrome.i18n.getMessage("locale__copy_all"))
        $(".locale__potential_no_total").text(chrome.i18n.getMessage("locale__potential_no_total"))
        $(".locale__potential_no_describe").text(chrome.i18n.getMessage("locale__potential_no_describe"))
        $(".locale__all_no_total").text(chrome.i18n.getMessage("locale__all_no_total"))
        $(".locale__all_no_describe").text(chrome.i18n.getMessage("locale__all_no_describe"))
        $(".locale__potential_save").text(chrome.i18n.getMessage("locale__potential_save"))
        $(".locale__instructions").text(chrome.i18n.getMessage("locale__instructions"))
        $(".locale__instructions_title").text(chrome.i18n.getMessage("locale__instructions_title"))
        $(".locale__engine_contact").text(chrome.i18n.getMessage("locale__engine_contact"))
        $(".locale__engine_save").text(chrome.i18n.getMessage("locale__engine_save"))
    }else{
        ui_locale = "zh-cn"
    }

    function tab_send_msg(tab = {}) {
        console.log(1);
        // chrome.tabs.update({
        //     url: tab.url
        // }, function(tab) {
        // chrome.tabs.onUpdated.addListener(function listener(tabId, changeInfo) {
        // console.log(tabId, changeInfo,"tabId, changeInfo");
        // if (tabId === tab.id && changeInfo.status == 'complete') {
        // console.log(tabId, changeInfo,"tabId, changeInfo");
        // chrome.tabs.onUpdated.removeListener(listener);
        if (parser.hostname.includes('google.') && parser.pathname.includes('/search')) {
            chrome.tabs.sendMessage(tab.id, {
                method: 'getInnerHTML'
            }, function (response) {
                console.log(55555);
                if (response) {
                    console.log(response, "response");
                    console.log(1.1);
                    // getDomainsFromGoogleSearch(response.data);
                    // console.log(2.1);
                    // if (googleResult && googleResult.length > 0) {
                    //     // chrome.runtime.sendMessage({
                    //     //     type: 'ga',
                    //     //     action: 'bulkDomainSearchShow'
                    //     // });

                    //     // renderDomains(googleResult);
                    // }

                    let domains = [];
                    // console.log(REG_GOOGLE_RESULT_URL.exec(source),"source");
                    let source = response.data || "";
                    const pattern = /\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,6}\b/g;
                    let email_list = source.match(pattern)
                    if (email_list && email_list.length > 0) {
                        console.log([...new Set(email_list)], "email_list");
                        // setTimeout(() => {
                        plugin_notify([...new Set(email_list)])
                        // }, 3000);

                    }
                    if (!REG_GOOGLE_RESULT_URL.exec(source)) {
                        console.log("jr");
                        // setTimeout(() => {
                        app_fun()
                        // }, 3000);

                        return false;
                    } else {
                        is_gs = true;
                    }

                    while (matches = REG_GOOGLE_RESULT_URL.exec(source)) {
                        if (!matches[1]) {
                            continue;
                        }

                        let res = REG_GOOGLE_RESULT_URL_TRIM.exec(matches[1]);
                        if (!res[1]) {
                            continue;
                        }

                        let url = res[1];

                        const domain = tldjs.getDomain(url);
                        if (domains.indexOf(domain) !== -1) {
                            continue;
                        }

                        if (isValidHttpUrl(url) === false) {
                            continue;
                        }

                        domains.push(domain);

                        googleResult.push({ domain, url });
                    }
                    
                    console.log(googleResult, domains, "googleResult");
                    saveDomainToSearch(domains)
                    companyLists()
                    if (googleResult.length > 0) {
                        $(".engine_list .see_all").text(`${chrome.i18n.getMessage("all")}${googleResult.length}`)
                        let html = "";
                        for (const key in googleResult) {
                            html += `
                            <div class="table_div active" data-domain="${googleResult[key].domain}" data-url="${googleResult[key].url}">
                                <div class="left">
                                    <div class="select">
                                        <img src="../img/select_n.png" class="n" alt="">
                                        <img src="../img/select_a.png" class="a" alt="">
                                    </div>
                                    <div class="contact" data-domain="${googleResult[key].domain}" data-url="${googleResult[key].url}">
                                        <div class="email_url">
                                            ${googleResult[key].domain}
                                        </div>
                                    </div>
                                </div>
                                <div class="right"></div>
                            </div>
                            `
                        }
                        $("#engine-tables").html(html)
                        $(".engine_list .select_show").removeClass("no_now_email")
                    } else {
                        $(".engine_list .select_show").addClass("no_now_email")
                        $(".engine_list .see_all").text(`${chrome.i18n.getMessage("all")}${googleResult.length}`)
                    }
                    layer_seerch_hide()
                    $(".app_loading").addClass("none");
                    $(".engine_list").removeClass("none")
                    return;
                } else {
                    layer_seerch_hide()
                    // layer.msg("请等待页面加载完成或刷新页面后重试");
                    $(".app_loading").addClass("none")
                    $(".no_search").removeClass("none")
                    console.log("errrrrr");
                }


            });
        } else {
            app_fun()
            chrome.tabs.sendMessage(tab.id, {
                method: 'getInnerHTML'
            }, function (response) {
                console.log(55555);
                if (response) {
                    console.log(response, "response");
                    console.log(1.1);
                    let domains = [];
                    let source = response.data || "";
                    const pattern = /\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,6}\b/g;
                    let email_list = source.match(pattern)
                    if (email_list && email_list.length > 0) {
                        // console.log([...new Set(email_list)], "email_list");
                        // setTimeout(() => {
                        plugin_notify([...new Set(email_list)])
                        // }, 3000);

                    }
                    layer_seerch_hide()
                    return;
                } else {
                    layer_seerch_hide()
                }


            });
        }

        // }
        // });
        // });
        // chrome.tabs.sendMessage(tab.id, {
        //     method: 'getInnerHTML'
        // }, function (response) {
        //     console.log(55555);
        //     if (response) {
        //         console.log(response,"response");
        //         console.log(1.1);
        //         // getDomainsFromGoogleSearch(response.data);
        //         // console.log(2.1);
        //         // if (googleResult && googleResult.length > 0) {
        //         //     // chrome.runtime.sendMessage({
        //         //     //     type: 'ga',
        //         //     //     action: 'bulkDomainSearchShow'
        //         //     // });

        //         //     // renderDomains(googleResult);
        //         // }

        //         let domains = [];
        //         // console.log(REG_GOOGLE_RESULT_URL.exec(source),"source");
        //         let source = response.data || "";
        //         const pattern = /\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,6}\b/g;
        //         let email_list=source.match(pattern)
        //         if(email_list&&email_list.length>0){
        //             console.log([...new Set(email_list)],"email_list");
        //             // setTimeout(() => {
        //                 plugin_notify([...new Set(email_list)])
        //             // }, 3000);

        //         }
        //         if (!REG_GOOGLE_RESULT_URL.exec(source)) {
        //             console.log("jr");
        //             // setTimeout(() => {
        //                 app_fun()
        //             // }, 3000);

        //             return false;
        //         }else{
        //             is_gs=true;
        //         }

        //         while (matches = REG_GOOGLE_RESULT_URL.exec(source)) {
        //             if (!matches[1]) {
        //                 continue;
        //             }

        //             let res = REG_GOOGLE_RESULT_URL_TRIM.exec(matches[1]);
        //             if (!res[1]) {
        //                 continue;
        //             }

        //             let url = res[1];

        //             const domain = tldjs.getDomain(url);
        //             if (domains.indexOf(domain) !== -1) {
        //                 continue;
        //             }

        //             if (isValidHttpUrl(url) === false) {
        //                 continue;
        //             }

        //                     domains.push(domain);

        //             googleResult.push({domain, url});
        //         }
        //         $(".app_loading").addClass("none");
        //         $(".engine_list").removeClass("none")
        //         console.log(googleResult,googleResult.length,"googleResult");
        //         companyLists()
        //         if(googleResult.length>0){
        //             $(".engine_list .see_all").text(`全部${googleResult.length}条`)
        //             let html="";
        //             for (const key in googleResult) {
        //                 html+=`
        //                 <div class="table_div active" data-domain="${googleResult[key].domain}" data-url="${googleResult[key].url}">
        //                     <div class="left">
        //                         <div class="select">
        //                             <img src="../img/select_n.svg" class="n" alt="">
        //                             <img src="../img/select_a.svg" class="a" alt="">
        //                         </div>
        //                         <div class="contact" data-domain="${googleResult[key].domain}" data-url="${googleResult[key].url}">
        //                             <div class="email_url">
        //                                 ${googleResult[key].domain}
        //                             </div>
        //                         </div>
        //                     </div>
        //                 </div>
        //                 `
        //             }
        //             $("#engine-tables").html(html)
        //             $(".engine_list .select_show").removeClass("no_now_email")
        //         }else{
        //             $(".engine_list .select_show").addClass("no_now_email")
        //             $(".engine_list .see_all").text(`全部${googleResult.length}条`)
        //         }
        //         layer_seerch_hide()
        //         return;
        //     }else{
        //         layer_seerch_hide()
        //         layer.msg("请等待页面加载完成或刷新页面后重试");
        //         console.log("errrrrr");
        //     }


        // }); 

    }
    // tab_send_msg()
    // function getDomainsFromGoogleSearch(source="") {
    //     console.log(2);

    // }
    function saveDomainToSearch(domains) {
        $.ajax({
            url: url + "plugin/saveDomainToSearch",
            type: "post",
            dataType: "json",
            async: false,
            headers: {
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            data: {
                domains,
            },
            success: (res) => {
                if (res.code == 1) {
                    $("#find-contacts").attr('href', res.data.url)
                } else {
                    if (res.code == 401 && sessionobj.value) {
                        window.chrome.cookies.remove({ url: website_url, name: 'sessionid' });
                        layer.msg(chrome.i18n.getMessage("session_overdue"));
                        setTimeout(() => {
                            window.open(`${website_url}login`)
                        }, 1500);
                    } else {
                        layer.msg(res.info);
                    }

                }
                console.log(res, "plugin/saveDomainToSearch");
            },
            error: (err) => {
                console.log(err, "plugin/saveDomainToSearch,err");
            }
        })
    }
    function isValidHttpUrl(string) {
        if (/^(?:\w+:)?\/\/([^\s\.]+\.\S{2}|localhost[\:?\d]*)\S*$/.test(string) === false) {
            return false;
        }

        let url;
        try {
            url = new URL(string);
        } catch (_) {
            return false;
        }

        return url.protocol === "http:" || url.protocol === "https:";
    }

    layer_login_show()
    get_cookieAll()
    function query_fun() {

        layer_seerch_show()
        chrome.tabs.query({ active: true, currentWindow: true }, tabs => {
            const currentTab = tabs[0];
            // tab_send_msg(tabs[0]);
            currentHost = tldjs.getDomain(currentTab.url);
            parser = document.createElement('a');
            parser.href = currentTab.url;
            console.log(parser.href, "parser");
            console.log(currentHost, "currentHost");
            if (!currentHost) {
                layer_seerch_hide()
                $(".app_loading").addClass("none")
                $(".no_search").removeClass("none")
            //     layer.msg("当前页面不支持查询");
                return false;
            }
            // if (parser.hostname.includes('google.') && parser.pathname.includes('/search')) {
            let bb = setInterval(() => {
                if(progress_bar > 90){
                    progress_bar = 100;
                }else {
                    progress_bar = progress_bar + 10;
                }
                $("#progress-bar-dark").css("width",progress_bar+'%')
                $("#progress-bar-percentage").text(progress_bar+'%')
            }, 110);
            setTimeout(() => {
                clearInterval(bb)
                tab_send_msg(tabs[0]);
            }, 300);



            // }else{
            // app_fun() 

            // }
        })
    }
    function get_cookieAll() {
        progress_bar = 10;
        $("#progress-bar-dark").css("width",progress_bar+"%")
        $("#progress-bar-percentage").text(progress_bar+"%")
        window.chrome.cookies.getAll({ url: website_url }, function (cookies) {
            sessionobj = {};
            cookies.map(item => {
                if (item.name == "Authorization") {
                    sessionobj.value = item.value;
                    sessionobj.time = item.expirationDate
                }
                // if(item.name=="username"){
                //     name=item.value;
                // }
            })

            if (sessionobj.value) {
                let bb = setInterval(() => {
                    progress_bar = progress_bar+3
                    $("#progress-bar-dark").css("width",progress_bar+'%')
                    $("#progress-bar-percentage").text(progress_bar+'%')
                }, 100);
                setTimeout(() => {
                    clearInterval(bb)
                    user_info()
                }, 1000);


            } else {
                layer_login_hide()
                // $(".to_login").attr("href",`${website_url}login`)
                // $(".to_rge").attr("href",`${website_url}register`)
                $(".app_loading").addClass("none")
                $(".login").removeClass("none")
            }
        })
    }

    function user_info() {
        $.ajax({
            url: url + "plugin/accountInfo",
            type: "post",
            dataType: "json",
            async: false,
            headers: {
                "Content-Type": "application/json;charset=utf-8",
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            success: (res) => {
                if (res.code == 1) {
                    let data = res.data.account
                    // console.log(res.data,"res.data");
                    $(".used_score").text(Number(data.plan.point) - Number(data.point))
                    $(".total_score").text(data.plan.point)
                    query_fun();
                } else {
                    if (res.code == 401 && sessionobj.value) {
                        window.chrome.cookies.remove({ url: website_url, name: 'sessionid' });
                        layer.msg(chrome.i18n.getMessage("session_overdue"));
                        setTimeout(() => {
                            window.open(`${website_url}login`)
                        }, 1500);
                    } else {
                        // $(".to_login").attr("href",`${website_url}login`)
                        // $(".to_rge").attr("href",`${website_url}register`)
                        $(".app_loading").addClass("none")
                        $(".login").removeClass("none")
                        layer.msg(res.info);
                    }

                }
                layer_login_hide()
                console.log(res, "res");
            },
            error: (err) => {
                layer_login_hide()
                // $(".to_login").attr("href",`${website_url}login`)
                // $(".to_rge").attr("href",`${website_url}register`)
                $(".app_loading").addClass("none")
                $(".login").removeClass("none")
                console.log(err, "accountInfo");
            }
        })
    }
    function layer_login_show() {
        
        // login_loading = layer.load(1, {
        //     shade: [0.1, '#fff'],
        //     offset: ['40%', "45%"],
        //     content: '<span class="login_loading_title">检测登录</span>',
        //     success: function (layer) {
        //         layer.find('.layui-layer-content').css({
        //             'padding-top': '40px',
        //             'width': '100px',
        //         });
        //         layer.find('.login_loading_title').css({
        //             'font-size': '20px',
        //             'margin-left': '-20px'
        //         });
        //     }
        // });
    }
    function layer_login_hide() {
        
        // layer.close(login_loading);
    }
    function layer_seerch_show() {
        $(".app__loading_title").text(chrome.i18n.getMessage("being_retrieved"))
        // search_loading = layer.load(1, {
        //     shade: [0.1, '#fff'],
        //     offset: ['40%', "45%"],
        //     content: '<span class="search_loading_title">正在搜索</span>',
        //     success: function (layer) {
        //         layer.find('.layui-layer-content').css({
        //             'padding-top': '40px',
        //             'width': '100px',
        //         });
        //         layer.find('.search_loading_title').css({
        //             'font-size': '20px',
        //             'margin-left': '-20px'
        //         });
        //     }
        // });
    }
    function layer_seerch_hide() {
        // layer.close(search_loading);
        progress_bar = 100;
        $("#progress-bar-dark").css("width",progress_bar+'%')
        $("#progress-bar-percentage").text(progress_bar+'%')
    }
    function companyLists(name) {
        $.ajax({
            url: url + "plugin/companyLists",
            type: "post",
            dataType: "json",
            async: false,
            headers: {
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            success: (res) => {
                if (res.code == 1) {
                    let data = res.data.list || [];
                    console.log(data, "data");
                    console.log(engine_list_id,'engine_list_id')
                    let html = ""
                    let none = "";
                    none = googleResult.length > 0 ? "" : "no_now_email";
                    let dataname = '';
                    if(name){
                        dataname =  name;
                    }else {
                        dataname =  engine_list_id;
                    }
                    if (data && data.length > 0) {
                        let name_obj = {};
                        if (name) {
                            for (const key in data) {
                                if (data[key].title === name) {
                                    name_obj = data[key]
                                }
                            }
                        } else if(engine_list_id){
                            for (const key in data) {
                                if (data[key].id === engine_list_id) {
                                    name_obj = data[key]
                                }
                            }
                        }
                        html += `
                            <div class="select_show ${none}">
                                <div class="lable" title="${dataname ? name_obj.title : data[0].title}" data-id="${dataname ? name_obj.id : data[0].id}">
                                    ${dataname ? name_obj.title : data[0].title}
                                </div>
                                <input type="text" id="add_engine_list_name" class="none" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                            </div>
                            <div class="select_down none">
                                <div class="add_option_input">
                                    <input type="text" id="add_potential_list_name_company" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                                    <button class="btn potential_save_company">创建</button>
                                </div>
                                <div class="option ${name ? name == data[0].title ? 'active' : '' : 'active'}" title="${data[0].title}" data-id="${data[0].id}">
                                    ${data[0].title}
                                </div>
                        `
                        for (let i = 1; i < data.length; i++) {
                            html += `
                                <div class="option ${name ? name == data[i].title ? 'active' : '' : ''}" title="${data[i].title}" data-id="${data[i].id}">
                                    ${data[i].title}
                                </div>  
                            `
                        }
                        html += `</div>`
                        if(!engine_list_id){
                            engine_list_id = data[0].id;
                        }
                        $(".engine_bottom .select_center").html(html)
                    } else {
                        html += `
                        <div class="select_show ${none}">
                            <div class="lable" title="">
                            ${chrome.i18n.getMessage("please_create_list")}
                            </div>
                            <input type="text" id="add_engine_list_name" class="none" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                        </div>
                        <div class="select_down none">
                            <div class="add_option_input">
                                <input type="text" id="add_potential_list_name_company" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                                <button class="btn potential_save_company">创建</button>
                            </div>
                        </div>
                        `
                        $(".engine_bottom .select_center").html(html)
                    }

                } else {
                    layer.msg(res.info);
                }
            },
            error: (err) => {
                console.log(err, "companyLists");
            }
        })
    }
    function prospectLists(name) {
        $.ajax({
            url: url + "plugin/prospectLists",
            type: "post",
            dataType: "json",
            async: false,
            headers: {
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            success: (res) => {
                if (res.code == 1) {
                    let data = res.data.list || [];
                    // total = data.length;
                    prospect_list = data;
                    console.log(data, "data");
                    let html = "";
                    let none = "";
                    if (type == "all") {
                        none = all_total > 0 ? "" : "no_now_email";
                    } else {
                        none = potential_total > 0 ? "" : "no_now_email";
                    }
                    let dataname = '';
                    if(name){
                        dataname =  name;
                    }else {
                        dataname =  list_id;
                    }
                    if (data && data.length > 0) {
                        let name_obj = {};
                        if (name) {
                            for (const key in data) {
                                if (data[key].title === name) {
                                    name_obj = data[key]
                                }
                            }
                        } else if(list_id){
                            for (const key in data) {
                                if (data[key].id === list_id) {
                                    name_obj = data[key]
                                }
                            }
                        }
                        html += `
                            <div class="select_show ${none}">
                                <div class="lable" title="${dataname ? name_obj.title : data[0].title}" data-id="${dataname ? name_obj.id : data[0].id}">${dataname ? name_obj.title : data[0].title}</div>
                                    <input type="text" id="add_potential_list_name" class="none" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                                </div>
                            <div class="select_down none">
                                <div class="add_option_input">
                                    <input type="text" id="add_potential_list_name_x" placeholder="${chrome.i18n.getMessage('create_list')}">
                                    <button class="btn potential_save_x">
                                        ${chrome.i18n.getMessage("create")}
                                    </button>
                                </div>
                                <div class="option ${name ? name == data[0].title ? 'active' : '' : 'active'}" title="${data[0].title}" data-id="${data[0].id}">${data[0].title}</div>`
                        for (let i = 1; i < data.length; i++) {
                            html += `<div class="option ${name ? name == data[i].title ? 'active' : '' : ''}" title="${data[i].title}" data-id="${data[i].id}">${data[i].title}</div>`
                        }
                        html += `</div>`

                        if(!list_id){
                            list_id = data[0].id;
                        }
                        $(".potential_bottom .select_center").html(html)
                    } else {
                        html += `
                            <div class="select_show ${none}">
                                <div class="lable" title="">${chrome.i18n.getMessage("please_create_list")}</div>
                                <input type="text" id="add_potential_list_name" class="none" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                            </div>
                            <div class="select_down none">
                                <div class="add_option_input">
                                    <input type="text" id="add_potential_list_name_x" placeholder="${chrome.i18n.getMessage('create_list')}">
                                    <button class="btn potential_save_x">
                                        ${chrome.i18n.getMessage("create")}
                                    </button>
                                </div>
                            </div>`
                        $(".potential_bottom .select_center").html(html)
                    }

                } else {
                    layer.msg(res.info);
                }
            },
            error: (err) => {
                console.log(err, "prospectLists");
            },
            complete: () => {
            }
        })
    }
    function prospectDataByList() {
        $.ajax({
            url: url + "plugin/prospectDataByList",
            type: "post",
            dataType: "json",
            data: {
                page: 1,
                limit: 200,
            },
            headers: {
                // "Content-Type":"application/json;charset=utf-8",
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            success: (res) => {

            },
            error: (err) => {
                console.log(err, "err");
            }
        })
    }
    $(document).on('click', '.add_one', function () {
        if (type == "all") {
            let email = $(this).data("email");
            if (!list_id) {
                if (!$("#add_potential_list_name").val()) {
                    layer.msg(chrome.i18n.getMessage("please_choose_list"));
                } else {
                    prospectAdd([email], "all", "name")
                }
            } else {
                prospectAdd([email], "all", "id")
            }
        } else {
            let id = $(this).data("id");
            if (!list_id) {
                if (!$("#add_potential_list_name").val()) {
                    layer.msg(chrome.i18n.getMessage("please_choose_list"));
                } else {
                    prospectAdd([id], "potential", "name")
                }
            } else {
                prospectAdd([id], "potential", "id")
            }
        }

    })
    function companyAddByDomains(domains, list_type) {
        // let engine_list_name = $("#add_engine_list_name").val()
        let engine_list_name = $("#add_potential_list_name_company").val()
        let data;
        if (list_type === "name") {
            data = {
                list_name: engine_list_name,
                // data: domains,
            }
        } else {
            data = {
                list_id: engine_list_id,
                data: domains,
            }
        }
        if (!isRequesting) {
            isRequesting = true;
            $.ajax({
                url: url + "plugin/companyAddByDomains",
                type: "post",
                dataType: "json",
                async: false,
                data,
                headers: {
                    "Authorization": sessionobj.value,
                    "lang": ui_locale,
                },
                success: (res) => {
                    if (res.code == 1) {
                        // let data = res.data.list || [];
                        // layer.msg(chrome.i18n.getMessage("add_success"));
                        if (list_type === "name") {
                            $(".engine_bottom .select .refresh").addClass("refresh36")
                            companyLists(engine_list_name)
                            engine_list_id = res.data.list_id;
                            setTimeout(() => {
                                $(".engine_bottom .select .refresh").removeClass("refresh36")
                            }, 1000);
                        }

                        let engine_list_title = $('.select_show .lable').attr('title');
                        if(list_type === "id"){
                            for (const i in domains) {
                                $(`#engine-tables .table_div[data-url="${domains[i].url}"]`).removeClass("active");
                                $(`#engine-tables .table_div[data-url="${domains[i].url}"] .right`).html(`<a href="${website_url}companies/list/${engine_list_id}" target="_blank">${engine_list_title}</a>`);
                            }
                        }
                        // for (const i in domains) {
                        //     $(`#all_tables .table_div[data-url="${domains[i].url}"]`).removeClass("active");
                        // }
                        // $('.engine_save').css('display','none');
                        // $('.engine_jump').css('display','block');
                        $('.engine_jump').html(`<a href="${website_url}companies/list/${engine_list_id}" target="_blank">转到列表</a>`);
                    } else {
                        layer.msg(res.info);
                    }
                    isRequesting = false;
                },
                error: (err) => {
                    isRequesting = false;
                    console.log(err, "companyAddByDomains");
                }
            })
        }
    }
    function companyAdd(list_type){
        let engine_list_name = $("#add_potential_list_name_company").val()
        let data;
        if (list_type === "name") {
            data = {
                list_name: engine_list_name,
            }
        } else {
            data = {
                list_id: engine_list_id,
            }
        }
        if (!isRequesting){
            isRequesting = true;
            $.ajax({
                url: url + "plugin/companyAdd",
                type: "post",
                dataType: "json",
                async: false,
                data,
                headers: {
                    "Authorization": sessionobj.value,
                    "lang":ui_locale,
                },
                success: (res) => {
                    if (res.code == 1) {
                        // let data = res.data.list || [];
                        layer.msg(chrome.i18n.getMessage("add_success"));
                        if (list_type === "name") {
                            $(".engine_bottom .select .refresh").addClass("refresh36")
                            companyLists(engine_list_name)
                            setTimeout(() => {
                                $(".engine_bottom .select .refresh").removeClass("refresh36")
                            }, 1000);
                        }
                        // for (const i in domains) {
                        //     $(`#all_tables .table_div[data-url="${domains[i.url]}"]`).removeClass("active");
                        // }
                    } else {
                        layer.msg(res.info);
                    }
                    isRequesting = false;
                },
                error: (err) => {
                    console.log(err, "companyAdd");
                    isRequesting = false;
                }
            })

        }
    }

    function prospectAdd(info, type, list_type) {
        let add_list_name = $("#add_potential_list_name").val()
        if (type == "all") {
            let data;
            if (list_type == "name") {
                data = {
                    list_name: add_list_name,
                    emails: info,
                }
            } else {
                data = {
                    list_id: list_id,
                    emails: info,
                }
            }
            $.ajax({
                url: url + "plugin/prospectEmailsAdd",
                type: "post",
                dataType: "json",
                async: false,
                data,
                headers: {
                    "Authorization": sessionobj.value,
                    "lang":ui_locale,
                },
                success: (res) => {
                    if (res.code == 1) {
                        // let data = res.data.list || [];
                        layer.msg(chrome.i18n.getMessage("add_success"));
                        if (list_type == "name") {
                            $(".potential_bottom .select .refresh").addClass("refresh36")
                            prospectLists(add_list_name)
                            setTimeout(() => {
                                $(".potential_bottom .select .refresh").removeClass("refresh36")
                            }, 1000);
                        }

                        if (list_type == "name") {
                            for (const i in info) {
                                $(`#all_tables .table_div[data-email="${info[i]}"]`).removeClass("active");
                                $(`#all_tables .table_div .btn[data-email="${info[i]}"]`).text(add_list_name).removeClass("add_one").addClass("added")
                            }
                        } else {
                            for (const i in info) {
                                $(`#all_tables .table_div[data-email="${info[i]}"]`).removeClass("active");
                                $(`#all_tables .table_div .btn[data-email="${info[i]}"]`).text($(".potential_bottom .select_show .lable").text()).removeClass("add_one").addClass("added")
                            }
                        }
                    } else {
                        layer.msg(res.info);
                    }
                },
                error: (err) => {
                    console.log(err, "prospectEmailsAdd");
                }
            })
        } else {
            let data;
            if (list_type == "name") {
                data = {
                    list_name: add_list_name,
                    list: info,
                }
            } else {
                data = {
                    list_id: list_id,
                    list: info,
                }
            }
            console.log(data, "prospectDataAdd_data");
            $.ajax({
                url: url + "plugin/prospectDataAdd",
                type: "post",
                dataType: "json",
                async: false,
                data,
                headers: {
                    "Authorization": sessionobj.value,
                    "lang":ui_locale,
                },
                success: (res) => {
                    if (res.code == 1) {
                        // let data = res.data.list || [];
                        layer.msg(chrome.i18n.getMessage("add_success"));
                        if (list_type == "name") {
                            $(".potential_bottom .select .refresh").addClass("refresh36")
                            prospectLists(add_list_name)
                            setTimeout(() => {
                                $(".potential_bottom .select .refresh").removeClass("refresh36")
                            }, 1000);
                        }

                        if (list_type == "name") {
                            for (const i in info) {
                                $(`#potential_tables .table_div[data-cyid="cy_${info[i]}"]`).removeClass("active")
                                $(`#potential_tables .table_div .btn[data-cyid="cy_${info[i]}"]`).text(add_list_name).removeClass("add_one").addClass("added")
                            }
                        } else {
                            for (const i in info) {
                                $(`#potential_tables .table_div[data-cyid="cy_${info[i]}"]`).removeClass("active")
                                $(`#potential_tables .table_div .btn[data-cyid="cy_${info[i]}"]`).text($(".potential_bottom .select_show .lable").text()).removeClass("add_one").addClass("added")
                            }
                        }
                    } else {
                        layer.msg(res.info);
                    }
                },
                error: (err) => {
                    console.log(err, "prospectDataAdd");
                }
            })
        }
    }

    function app_fun() {
        let company_ajaxurl = "";
        let company_data = {};
        let company_domain = tldjs.getDomain(parser.href);
        console.log(company_domain, "company_domain");
        //domain数据库暂未处理，先用url
        if (company_domain) {
            company_ajaxurl = "plugin/domainCompany";
            company_data = {
                // domain: parser.hostname,
                domain: currentHost,
            }
        } else {
            company_ajaxurl = "plugin/urlCompany";
            company_data = {
                url: parser.href,
            }
        }
        $.ajax({
            url: url + company_ajaxurl,
            type: "post",
            dataType: "json",
            async: false,
            data: company_data,
            headers: {
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            success: (res) => {
                console.log(res, "urlCompany");
                if (res.code == 1) {
                    // let data = res.data.company;
                    company_info = res.data.company;
                    $("#company-name-img").attr("src", `https://file.geeksend.com/static/company/logo/${company_info.logo}.jpg`)
                    $("#company-name-img").one("error", function (e) { console.log('logo图片无法加载'); $('#company-name-img').attr("src", "../img/logo_s2x.jpg"); });
                    // setTimeout(() => {
                    // let btnReset =  document.getElementById("company-name-id");
                    // btnReset.onerror = function(img){
                    //     img.src = "https://file.geeksend.com/static/company/logo.png";
                    //     // $("#company-name-id").attr("src",`https://file.geeksend.com/static/company/logo.png`)
                    // } 

                    // }, 1000);

                    // $("#company-name-img").attr("onerror",``)
                    // let timer = setInterval(() => {
                    // const dom = document.getElementById('company-name-img');
                    // if(dom.complete) {
                    //   console.log('图片加载成功')
                    //   clearInterval(timer);
                    // }
                    //  }, 50);
                    // dom.onerror= ()=> {
                    //     console.log(111111);
                    //     // _this.imgSrc = 验证失败后需要改的src;
                    // }
                    $("#company-linkedin").attr('href',company_info.link)
                    $("#company-url").attr('href', `https://app.geeksend.com/companies/view/${company_info.hash}`)
                    $("#company-name span").text(company_info.name)
                    $("#company-name span").attr("title", company_info.name)
                    // $("#company-url").attr("href",company_info.link)
                    getProspect();
                    getAllEmail();

                } else {
                    $("#used-score").text("0")
                    $("#total-score").text("0")
                    $(".content").remove()
                    $(".company").hide()
                    $(".app_loading").addClass("none")
                    $(".center").removeClass("none")
                    $(".app_center .select_show").addClass("no_now_email")
                    $(".potential_no_total").addClass("none")
                    $(".all_no_total").removeClass("none")
                    potential_total = 0;
                    all_total = 0;
                    $(".potential_bottom .select_show").addClass("no_now_email")
                    $(".potential_bottom .potential_save").attr("disabled", true)
                    layer.msg(chrome.i18n.getMessage("not_information"));
                    console.log("没公司信息");
                }
            },
            error: (err) => {
                potential_total = 0;
                all_total = 0;
                console.log(err, parser.href, "urlCompany");
                layer.msg(chrome.i18n.getMessage("network_interruption"));
            }
        })
        prospectLists();
        layer_seerch_hide()

    }
    function getProspect(){
        if(!isRequesting){
            isRequesting = true;
            $.ajax({
                url: url + "plugin/companyProspect",
                type: "post",
                dataType: "json",
                async: false,
                data: {
                    page: potentialPage,
                    limit: limit,
                    hash: company_info.hash,
                },
                headers: {
                    "Authorization": sessionobj.value,
                    "lang":ui_locale,
                },
                success: (companyProspect) => {
                    // console.log(res, "companyProspect");
                    if (companyProspect.code == 1) {
                        let potential_data = companyProspect.data.list;
                        if(potential_data.length > 0){
                            PotentialScrollTrue = true;
                            potentialPage++;
                        }
                        console.log(companyProspect, "potential_data");
                        if (potential_data.length > 0) {
                            potential_total = potential_data.length;
                            $(".app_loading").addClass("none")
                            $(".center").removeClass("none")
                            $(".app_center .select_show").removeClass("no_now_email")
                            let html = ""
                            for (let index = 0; index < potential_data.length; index++) {
                                let ins = "";
                                if(potential_data[index].social&&potential_data[index].social.length>0){
                                    let social = potential_data[index].socia;
                                    for (const key in social) {
                                        if (social[key].type=="social") {
                                            ins=`<a href="${social[key].link}" target="_blank" ><img src="../img/in.svg" alt=""></a>`
                                        }
                                    }
                                }
                                html += `
                                        <div class="table_div ${potential_data[index].list.length > 0 ? '' : 'active'}" id="potential-table-${potential_data[index].id}" data-id="${potential_data[index].id}" data-cyid="cy_${potential_data[index].id}" data-fullName="${potential_data[index].full_name}" data-position="${potential_data[index].position}">
                                            <div class="left">
                                                <div class="select">
                                                    <img src="../img/select_n.png" class="n" alt="">
                                                    <img src="../img/select_a.png" class="a" alt="">
                                                </div>
                                                <div class="contact">
                                                    <div class="name">
                                                        ${potential_data[index].full_name}  
                                                    </div>
                                                    <div class="position">
                                                        ${potential_data[index].position}${ins}
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="right">
                                                <div class="${potential_data[index].list.length > 0 ? 'btn added' : 'btn add_one'}" data-id="${potential_data[index].id}" data-cyid="cy_${potential_data[index].id}">
                                                    ${potential_data[index].list.length > 0 ? potential_data[index].list[0].prospect_list_name : '<img src="../img/add_white.svg" alt=""><span>'+chrome.i18n.getMessage("add")+'</span>'}
                                                </div>
                                                <div class="btn copy_one" data-id="${potential_data[index].id}" data-copyid="potential-table-${potential_data[index].id}">
                                                    <img src="../img/copy_s.svg" alt="">
                                                    <span>${chrome.i18n.getMessage("copy")}</span>
                                                </div>
                                            </div>
                                        </div>`

                            }
                            $(".potential_content .all_operation #see-potential").text(`${chrome.i18n.getMessage("look_all")}${companyProspect.data.total}`)
                            $(".potential_content .all_operation #see-potential").attr('href', `https://app.geeksend.com/companies/view/${company_info.hash}/prospects`)
                            $("#potential_tables").append(html);
                            potentialActiveNumbers();
                        } else {
                            $(".app_loading").addClass("none")
                            $(".center").removeClass("none")
                            $(".app_center .select_show").addClass("no_now_email")
                            potential_total = 0;
                            if (type == "potential") {
                                if(potentialActiveNumber === 0) {
                                    $(".all_no_total").addClass("none")
                                    $(".potential_no_total").removeClass("none")
                                }
                            }
                        }
                    } else {
                        potential_total = 0;
                        layer.msg(companyProspect.info);
                    }
                    isRequesting = false;
                },
                error: (err) => {
                    isRequesting = false;
                    console.log(err, "companyProspect");
                    layer.msg(chrome.i18n.getMessage("network_interruption"));
                }
            })
        }
    }
    function getAllEmail(){
        if(!isRequesting){
            isRequesting = true;
            $.ajax({
                url: url + "plugin/companyEmail",
                type: "post",
                dataType: "json",
                async: false,
                data: {
                    page: allPage,
                    limit: limit,
                    hash: company_info.hash,
                },
                headers: {
                    "Authorization": sessionobj.value,
                    "lang":ui_locale,
                },
                success: (companyEmail) => {
                    // console.log(res, "companyEmail");
                    if (companyEmail.code == 1) {
                        companyEmailTotal = companyEmail.data.total;
                        let all_data = companyEmail.data.list;
                        // console.log(companyEmail, "all_data");
                        if (all_data.length > 0) {
                            allScrollTrue = true;
                            allPage++;
                            all_total = all_data.length;
                            $(".app_loading").addClass("none")
                            $(".center").removeClass("none")
                            $(".app_center .select_show").removeClass("no_now_email")
                            let html = ""
                            for (let index = 0; index < all_data.length; index++) {
                                html += `
                                <div class="table_div ${all_data[index].list.length > 0 ? '' : 'active'}" id="all-table-${all_data[index].id}" data-id="${all_data[index].id}" data-email="${all_data[index].email}">
                                    <div class="left">
                                        <div class="select">
                                            <img src="../img/select_n.png" class="n" alt="">
                                            <img src="../img/select_a.png" class="a" alt="">
                                        </div>
                                        <div class="contact">
                                            <div class="email_url">
                                                ${all_data[index].email}
                                            </div>
                                        </div>
                                    </div>
                                    <div class="right">
                                        <div class="${all_data[index].list.length > 0 ? 'btn added' : 'btn add_one'}" data-email="${all_data[index].email}">${all_data[index].list.length > 0 ? all_data[index].list[0].prospect_list_name : '<img src="../img/add_white.svg" alt=""><span>'+chrome.i18n.getMessage("add")+'</span>'}</div>
                                        <div class="btn copy_one" data-id="${all_data[index].id}" data-copyid="all-table-${all_data[index].id}">
                                            <img src="../img/copy_s.svg" alt="">
                                            <span>${chrome.i18n.getMessage("copy")}</span>
                                        </div>
                                    </div>
                                </div>
                            `

                            }
                            $(".all_content .all_operation #see-all").text(`${chrome.i18n.getMessage("look_all")}${companyEmail.data.total}`)
                            $(".all_content .all_operation #see-all").attr('href', `https://app.geeksend.com/companies/view/${company_info.hash}/emails`)
                            $("#all_tables").append(html)
                            let all_emails_list=[];
                            $('#all_tables .active').each(function () {
                                email = $(this).data('email');
                                all_emails_list.push(email);
                            });
                            if (!all_emails_list || all_emails_list.length < 1) {
                                $(".potential_bottom .potential_save").attr("disabled", true)
                            }
                            activeNumber();
                        } else {
                            $(".app_loading").addClass("none")
                            $(".center").removeClass("none")
                            $(".potential_bottom .select_show").addClass("no_now_email")
                            $(".potential_bottom .potential_save").attr("disabled", true)
                            all_total = 0;
                            if (type == "all") {
                                if(allActiveNumber === 0){
                                    $(".potential_no_total").addClass("none")
                                    $(".all_no_total").removeClass("none")
                                }
                            }
                        }
                    } else {
                        all_total = 0;
                        layer.msg(companyEmail.info);
                    }
                    isRequesting = false;
                },
                error: (err) => {
                    console.log(err, "companyEmail");
                    isRequesting = false;
                    layer.msg(chrome.i18n.getMessage("network_interruption"));
                }
            })
        }
    }

    function plugin_notify(list) {
        $.ajax({
            url: url + "plugin/notify",
            type: "post",
            dataType: "json",
            data: {
                url: parser.href,
                domain: parser.hostname,
                emails: list,
            },
            headers: {
                "Authorization": sessionobj.value,
                "lang":ui_locale,
            },
            success: (res) => {

            },
            error: (err) => {

            }
        })
    }

    $(".potential_content .active_all").on('click', function () {
        const selection = window.getSelection();
        selection.removeAllRanges();
        let all_active = true;
        $(".potential_content .table_div").each(function (index, value) {
            if (!value.classList.value.includes("active")) {
                all_active = false;
            }
        })
        if (all_active) {
            $(".potential_content .table_div").removeClass("active")
            $(this).removeClass("active")
        } else {
            $(".potential_content .table_div").addClass("active")
            $(this).addClass("active")
        }
        potential_list_choose()
        potentialActiveNumbers();

    })
    $(".all_content .active_all").on('click', function () {
        const selection = window.getSelection();
        selection.removeAllRanges();
        let all_active = true;
        $(".all_content .table_div").each(function (index, value) {
            if (!value.classList.value.includes("active")) {
                all_active = false;
            }
        })
        if (all_active) {
            $(".all_content .table_div").removeClass("active")
            $(this).removeClass("active")
        } else {
            $(".all_content .table_div").addClass("active")
            $(this).addClass("active")
        }
        all_list_choose()
        activeNumber();
    })
    $(".engine_list .active_all").on('click', function () {
        const selection = window.getSelection();
        selection.removeAllRanges();
        let all_active = true;
        $(".engine_list .table_div").each(function (index, value) {
            if (!value.classList.value.includes("active")) {
                all_active = false;
            }
        })
        if (all_active) {
            $(".engine_list .table_div").removeClass("active")
            $(this).removeClass("active")
        } else {
            $(".engine_list .table_div").addClass("active")
            $(this).addClass("active")
        }
    })
    $('.potential_type').on('click', function () {
        $(".switch_active").removeClass("all").addClass("potential")
        $(this).addClass("active").siblings(".switch_type").removeClass("active")
        type = "potential";
        if (potential_total > 0) {
            $(".potential_content").removeClass("none")
            $(".potential_no_total").addClass("none")
            $(".all_content").addClass("none")
            $(".all_no_total").addClass("none")
            $(".potential_bottom .select_show").removeClass("no_now_email")
            potential_list_choose()
        } else {
            $(".potential_content").addClass("none")
            $(".potential_no_total").removeClass("none")
            $(".all_content").addClass("none")
            $(".all_no_total").addClass("none")
            $(".potential_bottom .select_show").addClass("no_now_email")
            $(".potential_bottom .potential_save").attr("disabled", true)
        }
        console.log(potential_total, "potential_total");
    })
    $('.all_type').on('click', function () {
        $(".switch_active").removeClass("potential").addClass("all")
        $(this).addClass("active").siblings(".switch_type").removeClass("active")
        type = "all";
        if (all_total > 0) {
            $(".all_content").removeClass("none")
            $(".all_no_total").addClass("none")
            $(".potential_content").addClass("none")
            $(".potential_no_total").addClass("none")
            $(".potential_bottom .select_show").removeClass("no_now_email")
            $(".potential_bottom .potential_save").attr("disabled", false)
            all_list_choose()
        } else {
            $(".all_content").addClass("none")
            $(".all_no_total").removeClass("none")
            $(".potential_content").addClass("none")
            $(".potential_no_total").addClass("none")
            $(".potential_bottom .select_show").addClass("no_now_email")
            $(".potential_bottom .potential_save").attr("disabled", true)
        }
        console.log(all_total, "all_total");
    })
    $(document).on('click', '.copy_one', function () {
        let id = $(this).data("copyid");
        $(`#${id}`).addClass("text")
        // copyDivContent(id)
        singleCopyDivContent(id);
    })
    $(document).on('click', '.added', function () {
        let name = $(this).text();
        console.log(name, "added name");
        for (const key in prospect_list) {
            if (prospect_list[key].title === name) {
                window.open(`https://app.geeksend.com/prospects/list/${prospect_list[key].id}`)
            }
        }
    })
    //判断选择全部是否展示选中样式
    function active_all_a() {
        if ($(".engine_list").hasClass("none")) {
            if (type == "all") {
                let all_active = true;
                $(".all_content .table_div").each(function (index, value) {
                    if (!value.classList.value.includes("active")) {
                        all_active = false;
                    }
                })
                if (all_active) {
                    $(".all_content .active_all").addClass("active")
                } else {
                    $(".all_content .active_all").removeClass("active")
                }
                all_list_choose()
            } else {
                let potential_active = true;
                $(".potential_content .table_div").each(function (index, value) {
                    if (!value.classList.value.includes("active")) {
                        potential_active = false;
                    }
                })
                if (potential_active) {
                    $(".potential_content .active_all").addClass("active")
                } else {
                    $(".potential_content .active_all").removeClass("active")
                }
                potential_list_choose()
            }
        } else {
            let engine_active = true;
            $(".engine_content .table_div").each(function (index, value) {
                if (!value.classList.value.includes("active")) {
                    engine_active = false;
                }
            })
            if (engine_active) {
                $(".engine_content .active_all").addClass("active")
            } else {
                $(".engine_content .active_all").removeClass("active")
            }
        }
    }
    $(document).on('click', '.table_div .select', function () {
        const selection = window.getSelection();
        selection.removeAllRanges();
        if ($(this).parent().parent().hasClass("active")) {
            $(this).parent().parent().removeClass("active")
        } else {
            $(this).parent().parent().addClass("active")
        }
        active_all_a();
        activeNumber();
        potentialActiveNumbers();

    })
    $(document).on('click', '.potential_bottom .select_show', function (e) {
        e.stopPropagation();
        console.log(e.target.classList, "e.target");
        // if(e.target.classList.length>1&&e.target.classList[1]=='no_now_email'){
        //     return false;
        // }
        if (e.target.id != "add_potential_list_name") {
            console.log("下拉框");
            if ($(".potential_bottom .select_down").hasClass("none")) {
                $(".potential_bottom .select_down").removeClass("none")
                $(".potential_bottom .icon .arrow").addClass("rot18")
                console.log("展示下拉框");
            } else {
                $(".potential_bottom .select_down").addClass("none")
                $(".potential_bottom .icon .arrow").removeClass("rot18")
                console.log("隐藏下拉框");
            }
        }
    })
    $(document).on('click', '.potential_bottom .arrow', function (e) {
        e.stopPropagation();
        if ($(".potential_bottom .select_down").hasClass("none")) {
            $(".potential_bottom .select_down").removeClass("none")
            $(".potential_bottom .icon .arrow").addClass("rot18")
            console.log("展示下拉框");
        } else {
            $(".potential_bottom .select_down").addClass("none")
            $(".potential_bottom .icon .arrow").removeClass("rot18")
            console.log("隐藏下拉框");
        }
    })
    $(document).on('click', '.potential_bottom .select .refresh', function (e) {
        e.stopPropagation();
        $(".potential_bottom .select .refresh").addClass("refresh36")
        $(".potential_bottom .select_down").addClass("none")
        prospectLists()
        setTimeout(() => {
            $(".potential_bottom .select .refresh").removeClass("refresh36")
        }, 1000);
        if (type == "all") {
            if (all_total > 0) {
                $(".potential_bottom .select_show").removeClass("no_now_email")
                all_list_choose()
            } else {
                $(".potential_bottom .select_show").addClass("no_now_email")
                $(".potential_bottom .potential_save").attr("disabled", true)
            }
        } else {
            if (potential_total > 0) {
                $(".potential_bottom .select_show").removeClass("no_now_email")
                potential_list_choose()
            } else {
                $(".potential_bottom .select_show").addClass("no_now_email")
                $(".potential_bottom .potential_save").attr("disabled", true)
            }
        }

    })
    function all_list_choose(){
        let all_emails_list=[];
        $('#all_tables .right > .add_one').each(function () {
            let email = $(this).data('email');
            all_emails_list.push(email);
        });
        $('#all_tables .active').each(function () {
            let email = $(this).data('email');
            all_emails_list.push(email);
        });
        if (!all_emails_list || all_emails_list.length < 1) {
            $(".potential_bottom .potential_save").attr("disabled", true)
        }else{
            $(".potential_bottom .potential_save").attr("disabled", false)
        }
    }
    function potential_list_choose(){
        let all_emails_list=[];
        $('#potential_tables .right > .add_one').each(function () {
            let cyid = $(this).data('cyid');
            all_emails_list.push(cyid);
        });
        $('#potential_tables .active').each(function () {
            let cyid = $(this).data('cyid');
            all_emails_list.push(cyid);
        });
        if (!all_emails_list || all_emails_list.length < 1) {
            $(".potential_bottom .potential_save").attr("disabled", true)
        }else{
            $(".potential_bottom .potential_save").attr("disabled", false)
        }
    }
    $(document).on('click', '.potential_bottom .select_down .option', function () {
        list_id = $(this).data("id")
        $(this).addClass("active").siblings(".option").removeClass("active")
        $(".potential_bottom .select_show .lable").text($(this).attr("title"))
        $(".potential_bottom .select_show .lable").attr("title", $(this).attr("title"))
        $(".potential_bottom .select_down").addClass("none")
        $(".potential_bottom .select_show .lable").removeClass("none")
        $(".potential_bottom #add_potential_list_name").val("").attr("value", "")
        $(".potential_bottom #add_potential_list_name").addClass("none")
        $(".potential_bottom .potential_save").attr("disabled", false)
        $(".potential_bottom .icon .arrow").removeClass("rot18")
        if (type == "all") {
            if (all_total > 0) {
                $(".potential_bottom .select_show").removeClass("no_now_email")
                all_list_choose()
            } else {
                $(".potential_bottom .select_show").addClass("no_now_email")
                $(".potential_bottom .potential_save").attr("disabled", true)
            }
        } else {
            if (potential_total > 0) {
                $(".potential_bottom .select_show").removeClass("no_now_email")
                potential_list_choose()
            } else {
                $(".potential_bottom .select_show").addClass("no_now_email")
                $(".potential_bottom .potential_save").attr("disabled", true)
            }
        }
    })

    $(document).on('click', '.engine_bottom .select_show', function (e) {
        e.stopPropagation();
        if (e.target.id != "add_engine_list_name") {
            if ($(".engine_bottom .select_down").hasClass("none")) {
                $(".engine_bottom .select_down").removeClass("none")
                $(".engine_bottom .select .icon .arrow").addClass("rot18")
            } else {
                $(".engine_bottom .select_down").addClass("none")
                $(".engine_bottom .select .icon .arrow").removeClass("rot18")
            }
        }
    })
    $(document).on('click', '.engine_bottom .arrow', function (e) {
        e.stopPropagation();
        if ($(".engine_bottom .select_down").hasClass("none")) {
            $(".engine_bottom .select_down").removeClass("none")
            $(".engine_bottom .select .icon .arrow").addClass("rot18")
        } else {
            $(".engine_bottom .select_down").addClass("none")
            $(".engine_bottom .select .icon .arrow").removeClass("rot18")
        }
    })
    $(document).on('click', '.engine_bottom .select .refresh', function (e) {
        e.stopPropagation();
        $(".engine_bottom .select .refresh").addClass("refresh36")
        $(".engine_bottom .select_down").addClass("none")
        companyLists()
        setTimeout(() => {
            $(".engine_bottom .select .refresh").removeClass("refresh36")
        }, 1000);
    })
    $(document).on('click', '.engine_bottom .select_down .option', function () {
        engine_list_id = $(this).data("id")
        $(this).addClass("active").siblings(".option").removeClass("active")
        $(".engine_bottom .select_show .lable").text($(this).attr("title"))
        $(".engine_bottom .select_show .lable").attr("title", $(this).attr("title"))
        $(".engine_bottom .select_down").addClass("none")
        $(".engine_bottom .select_show .lable").removeClass("none")
        $(".engine_bottom #add_engine_list_name").val("").attr("value", "")
        $(".engine_bottom #add_engine_list_name").addClass("none")
        $(".engine_bottom .engine_save").attr("disabled", false)
        $(".engine_bottom .select .icon .arrow").removeClass("rot18")
    })

    function copyDivContent(divId) {
        let all_emails = [];
        if (type === 'all'){
            $('#all_tables .active').each(function () {
                email = $(this).data('email');
                all_emails.push(email);
            });
        }else {
            $('#potential_tables .active').each(function () {
                fullname = $(this).data('fullname');
                position = $(this).data('position');
                all_emails.push(fullname+','+position);
            });
        }
        let div = document.getElementById(divId);
        const range = document.createRange();
        range.selectNodeContents(div);
        const originalContent = all_emails.join();
        const filteredContent = originalContent.replace(/,/g, '\n');
        const textarea = document.createElement('textarea');
        textarea.value = filteredContent;
        document.body.appendChild(textarea);
        textarea.select();
        document.execCommand('copy');
        document.body.removeChild(textarea);
        const selection = window.getSelection();
        selection.removeAllRanges();
        selection.addRange(range);
        layer.msg(chrome.i18n.getMessage("copy_success"));
    }

    function singleCopyDivContent(divId) {
        let data = ''
        if (type === 'all'){
            data = $('#'+divId).data('email');
        }else {
            data = $('#'+divId).data('fullname')+','+$('#'+divId).data('position');
        }
        console.log(data)
        // let div = document.getElementById(divId);
        // const range = document.createRange();
        // range.selectNodeContents(div);
        // const originalContent = all_emails.join();
        const filteredContent = data.replace(/,/g, '\n');
        const textarea = document.createElement('textarea');
        textarea.value = filteredContent;
        document.body.appendChild(textarea);
        textarea.select();
        document.execCommand('copy');
        document.body.removeChild(textarea);
        // const selection = window.getSelection();
        // selection.removeAllRanges();
        // selection.addRange(range);
        layer.msg(chrome.i18n.getMessage("copy_success"));
    }

    $(document).on('click', '.potential_content .copy_all', function () {
        const selection = window.getSelection();
        selection.removeAllRanges();
        let all_active = false;
        $(".potential_content .table_div").each(function (index, value) {
            if (value.classList.value.includes("active")) {
                all_active = true;
            }
        })
        if (all_active) {
            $(".potential_content .table_div .contact").removeClass("text")
            copyDivContent("potential_tables")
        } else {
            layer.msg(chrome.i18n.getMessage("please_select_content"));
        }
    })
    $(document).on('click', '.all_content .copy_all', function () {
        const selection = window.getSelection();
        selection.removeAllRanges();
        let all_active = false;
        $(".all_content .table_div").each(function (index, value) {
            if (value.classList.value.includes("active")) {
                all_active = true;
            }
        })
        if (all_active) {
            $(".all_content .table_div .contact").removeClass("text")
            copyDivContent("all_tables")
        } else {
            layer.msg(chrome.i18n.getMessage("please_select_content"));
        }
    })
    $(document).on('click', '.engine_list .engine_save', function () {
        if ($(".engine_list .engine_bottom").hasClass("n")) {
            $(".engine_list .engine_bottom").removeClass("n")
        } else {
            all_urls = [];
            $('#engine-tables .active').each(function () {
                let obj = {
                    domain: $(this).data('domain'),
                    url: $(this).data('url'),
                }
                all_urls.push(obj);
            });
            if (!all_urls) {
                layer.msg(chrome.i18n.getMessage("please_choose_save_data"));
            } else if (!engine_list_id) {
                if (!$("#add_engine_list_name").val()) {
                    layer.msg(`${chrome.i18n.getMessage("please_choose_list")}`);
                } else {
                    console.log(all_urls,"name");
                    companyAddByDomains(all_urls, "name")
                }
            } else {
                console.log(all_urls, "id");
                companyAddByDomains(all_urls, "id")
            }
        }
    })
    $(document).on('click', '.potential_save_company', function () {
        // companyAdd("name");
        companyAddByDomains('', "name")
    });
    $(document).on('click', '.engine_bottom .add_option', function () {
        engine_list_id = "";
        $(".engine_bottom .select_down").addClass("none")
        $(".engine_bottom .select_show .lable").addClass("none")
        $("#add_engine_list_name").val("").attr("value", "")
        $("#add_engine_list_name").removeClass("none")
        $(".engine_save").attr("disabled", true)
        $(".engine_bottom .select .icon .arrow").removeClass("rot18")
        $(".engine_bottom .select_down .option").removeClass("active")
    })
    $(document).on('input porpertychange', '#add_engine_list_name', function (e) {
        e.stopPropagation();
        if ($(this).val() != "") {
            $(".engine_save").attr("disabled", false)
        } else {
            $(".engine_save").attr("disabled", true)
        }

    })
    $(document).on('click', '.potential_bottom .add_option', function () {
        list_id = "";
        $(".potential_bottom .select_down").addClass("none")
        $(".potential_bottom .select_show .lable").addClass("none")
        $("#add_potential_list_name").val("").attr("value", "")
        $("#add_potential_list_name").removeClass("none")
        $(".potential_save").attr("disabled", true)
        $(".potential_bottom .select .icon .arrow").removeClass("rot18")
        $(".potential_bottom .select_down .option").removeClass("active")
    })
    $(document).on('input porpertychange', '#add_potential_list_name', function (e) {
        e.stopPropagation();
        if ($(this).val() != "") {
            if (type == "all") {
                if (all_total > 0) {
                    all_list_choose()
                } else {
                    $(".potential_bottom .potential_save").attr("disabled", true)
                }
            } else {
                if (potential_total > 0) {
                    potential_list_choose()
                } else {
                    $(".potential_bottom .potential_save").attr("disabled", true)
                }
            }
        } else {
            $(".potential_save").attr("disabled", true)
        }

    })
    $(document).on('click', '.potential_save', function () {
        if (type == "all") {
            all_emails = [];
            $('#all_tables .active').each(function () {
                email = $(this).data('email');
                all_emails.push(email);
            });
            console.log(all_emails, "all_emails");
            if (!all_emails || all_emails.length < 1) {
                layer.msg(chrome.i18n.getMessage("please_choose_save_data"));
            } else if (!list_id) {
                if (!$("#add_potential_list_name").val()) {
                    layer.msg(chrome.i18n.getMessage("please_choose_list"));
                } else {
                    console.log("name");
                    prospectAdd(all_emails, "all", "name")
                }
            } else {
                console.log("id");
                prospectAdd(all_emails, "all", "id")
            }
            activeNumber();
        } else {
            potential_info = [];
            $('#potential_tables .active').each(function () {
                id = $(this).data('id');
                potential_info.push(id);
            });
            if (!potential_info || potential_info.length < 1) {
                layer.msg(chrome.i18n.getMessage("please_choose_save_data"));
            } else if (!list_id) {
                if (!$("#add_potential_list_name").val()) {
                    layer.msg(chrome.i18n.getMessage("please_choose_list"));
                } else {
                    console.log("name");
                    prospectAdd(potential_info, "potential", "name")
                }
            } else {
                console.log("id");
                prospectAdd(potential_info, "potential", "id")
            }
            potentialActiveNumbers();
        }

    })
    // chrome.runtime.sendMessage({
    //     wakeMeUp: true
    // }, response => {
    //     setTimeout(() => {
    //         chrome.runtime.sendMessage({
    //             type: 'checkNews'
    //         }, response => {
    //             if (response && response.isNeedToShowNews) {
    //                 console.log("有信息");
    //             }
    //         });

    //         chrome.runtime.sendMessage({ checkIfNewVersion: true }, response => {
    //             if (!response) {
    //                 return;
    //             }

    //             // $('#downloadNewVersion').removeClass('hidden');
    //             // $('#showLastNews').addClass('hidden');
    //             // showNewVersionBanner();

    //             // $('#downloadNewVersion').click(() => {
    //             //     $('#downloadNewVersion').addClass('hidden');
    //             //     chrome.runtime.sendMessage({ updateExtensionVersion: true });
    //             // });
    //         });
    //     }, 1000);
    // });

    // chrome.action.setBadgeText({text:"1"})
    // chrome.action.setBadgeBackgroundColor({ color: 'red' });
    // document.addEventListener("error", function (e) {

    //     var elem = e.target;
    //     console.log(elem,"elem");
    //     if (elem.tagName.toLowerCase() == "img") {

    //         elem.src = "https://file.geeksend.com/static/company/logo.png";

    //     }

    // }, true);
    function prospectListCreate(info, type, list_type) {
        layer.load(1, {
            shade: [0.5, "#ccc"],
        });
        let add_list_name = $("#add_potential_list_name_x").val();

        let data;
        data = {
            title: add_list_name,
        };
        console.log(data, "prospectListCreate_data");
        $.ajax({
            url: url + "plugin/prospectListCreate",
            type: "post",
            dataType: "json",
            // async: false,
            xhrFields: {
                withCredentials: false,
            },
            data,
            headers: {
                Authorization: sessionobj.value,
                lang: ui_locale,
            },
            success: (res) => {
                console.log(res)
                if (res.code == 1) {
                    // let data = res.data.list || [];
                    layer.msg(chrome.i18n.getMessage("list_add_success"));

                    let data = res.data.list || [];
                    // total = data.length;
                    prospect_list = data;
                    console.log(data, "data");
                    let html = "";
                    let none = "";
                    // if (type == "all") {
                    //     none = all_total > 0 ? "" : "no_now_email";
                    // } else {
                    none = potential_total > 0 ? "" : "no_now_email";
                    // }
                    if (data && data.length > 0) {
                        let name_obj = {};
                        if (name) {
                            for (const key in data) {
                                if (data[key].title == name) {
                                    name_obj = data[key];
                                }
                            }
                        }
                        html += `<div class="select_show ${none}"><div class="lable" title="${
                            name ? name_obj.title : data[0].title
                        }" data-id="${name ? name_obj.id : data[0].id}">${
                            name ? name_obj.title : data[0].title
                        }</div>
            </div>
            <div class="select_down none">
              <div class="add_option_input">
                <input type="text" id="add_potential_list_name_x" placeholder="${chrome.i18n.getMessage(
                            "new_name_list"
                        )}">
                <button class="btn potential_save_x">
                  ${chrome.i18n.getMessage("create")}
                </button>
              </div>
            <div class="option ${
                            name ? (name == data[0].title ? "active" : "") : "active"
                        }" title="${data[0].title}" data-id="${data[0].id}">${
                            data[0].title
                        }</div>`;
                        for (let i = 1; i < data.length; i++) {
                            html += `<div class="option ${
                                name ? (name == data[i].title ? "active" : "") : ""
                            }" title="${data[i].title}" data-id="${data[i].id}">${
                                data[i].title
                            }</div>`;
                        }
                        html += `</div>`;
                        list_id = data[0].id;
                        $(".potential_bottom .select_center").html(html);
                    } else {
                        html += `<div class="select_show ${none}"><div class="lable" title="">${chrome.i18n.getMessage(
                            "please_create_list"
                        )}</div><input type="text" id="add_potential_list_name" class="none" placeholder="${chrome.i18n.getMessage(
                            "new_name_list"
                        )}"></div>
                        <div class="select_down none">
                            <div class="add_option_input">
                                <input type="text" id="add_potential_list_name_company" placeholder="${chrome.i18n.getMessage("new_name_list")}">
                                <button class="btn potential_save_company">创建</button>
                            </div>
                        </div>`;
                        $(".potential_bottom .select_center").html(html);
                    }

                } else {
                    layer.msg(res.info);
                }
            },
            error: (err) => {
                layer.msg(res.info);
                console.log(err, "prospectDataAdd");
            },
            complete: () => {
                layer.closeAll("loading");
            },
        });
    }
    function activeNumber(){
        all_active_emails = [];
        $('#all_tables .active').each(function () {
            email = $(this).data('email');
            all_active_emails.push(email);
        });
        allActiveNumber = all_active_emails.length;
        $('#allActiveNumber').html(allActiveNumber);
    }
    function potentialActiveNumbers(){
        potential_info = [];
        $('#potential_tables .active').each(function () {
            id = $(this).data('id');
            potential_info.push(id);
        });
        potentialActiveNumber = potential_info.length;
        $('#potentialActiveNumber').html(potentialActiveNumber);
    }
    // 添加目录
    $(document).on("click", ".potential_save_x", function () {
        // layer.msg('保存成功');
        if (!$("#add_potential_list_name_x").val()) {
            layer.msg(chrome.i18n.getMessage("please_choose_list"));
        } else {
            // console.log("name");
            prospectListCreate();
        }
    });
    $('#all_tables_scroll').scroll(function () {
        // 获取滚动条距离顶部的距离
        let scrollTop = $(this).scrollTop();
        // 获取页面的高度
        let scrollHeight = $('#all_tables').height();
        // 获取窗口高度
        let windowHeight = $(this).height();
        // 当滚动条距离底部还有100PX时，加载更多内容
        if (scrollHeight - scrollTop - windowHeight < 5) {
            if(companyEmailTotal > 20){
                if(allScrollTrue){
                    allScrollTrue = false;
                    getAllEmail();
                }
            }
        }
    });
    $('#potential_tables_scroll').scroll(function () {
        // 获取滚动条距离顶部的距离
        let scrollTop = $(this).scrollTop();
        // 获取页面的高度
        let scrollHeight = $('#potential_tables').height();
        // 获取窗口高度
        let windowHeight = $(this).height();
        // 当滚动条距离底部还有100PX时，加载更多内容
        if (scrollHeight - scrollTop - windowHeight < 5) {
            if(PotentialScrollTrue){
                PotentialScrollTrue = false;
                getProspect();
            }
        }
    });
})